#!/bin/bash
# build and install power installer

deps="cmake libgtk-3-dev libnotify-bin libgranite-dev valac-0.26"

if ! dpkg -s $deps >/dev/null 2>&1; then
    sudo apt-get install $deps
fi

dir="$(dirname $0)"

cd "$dir"
if [ -d "build/" ]; then
  sudo rm -rf build
fi

mkdir build
cd build

cmake .. -DCMAKE_INSTALL_PREFIX=/usr
make
sudo make install

cd ../
rm -rf build/
cd src/
rm config.vala
cd

echo "Successfully builded and installed!"
read "EXIT"

exit
