#!/usr/bin/env python -B
## part of power installer

import subprocess
import sys
from os import remove
from coreconf import show, homedir

action = sys.argv[1]
msgsucess = sys.argv[2]

def exe_action(cmd, driver=''):
    logactpath = '/tmp/pi_action_log.txt'
    logactfile = open(logactpath, 'w+r')
    run_act = subprocess.Popen(cmd, stdout=subprocess.PIPE, stderr=subprocess.STDOUT, shell=True)

    # write line to stdout and to file
    for line in run_act.stdout:
        sys.stdout.write(line)
        logactfile.write(line)

    streamwait = run_act.communicate()[0]

    if run_act.returncode == 0:
        show(msgsucess, 'false')
        remove(logactpath)
    else:
        show('Something went wrong. Check out: /tmp/pi_action_log.txt for more information.', 'true')
        sys.exit(1)

    if driver != '':
        if driver == 'ati':
            removedpkg = 'fglrx fglrx-amdcccle'
        else:
            removedpkg = 'nvidia-graphics-drivers-343 nvidia-settings'

        driver_file = open(homedir + '/revert_drivers.sh', 'w+r')
        file_data ='''#!/bin/bash
# AUTOGENERATED BY POWER INSTALLER
sudo add-apt-repository --remove ppa:xorg-edgers/ppa
sudo apt-get update
sudo apt-get remove --purge''' + removedpkg + '\nexit "$?"'
        driver_file.write(file_data)
        driver_file.close()
        show('If the installtion fails, please run "bash revert_drivers.sh" to revert the changes.', 'false')

    sys.exit(0)

if action == 'update': exe_action('apt-get update')
elif action == 'configure': exe_action('dpkg --configure -a')
elif action == 'repair': exe_action('apt-get install -f -y')
elif action == 'removepkg': exe_action('apt-get autoremove -y')
elif action == 'ati': exe_action('add-apt repository -y ppa:xorg-edgers/ppa; apt-get update; apt-get install -y fglrx fglrx-amdcccle', 'ati')
elif action == 'nvidia': exe_action('add-apt repository -y ppa:xorg-edgers/ppa; apt-get update; apt-get install -y nvidia-graphics-drivers-343 nvidia-settings', 'nvidia')
