#!/usr/bin/python -B
## part of power installer
# notify system & workaround for policykit

import os
import pynotify
import sys
import pwd
import subprocess
from coreconf import user

def send(message, error, icon='power-installer'):
    if pynotify.init('Power Installer'):

        # drop permissions
        uid = pwd.getpwnam(user)[2]
        os.setuid(uid)

        if message + error == '':
            message = 'Working... You will be notified after all work will be done!'
            error = 'false'
        elif error == 'true':
            icon = 'error'

        n = pynotify.Notification('Power Installer', message, icon)
        n.set_urgency(pynotify.URGENCY_CRITICAL)
        n.show()
    else:
        print('ERROR: Could not initialize pynotify!')

message = sys.argv[1]
error = sys.argv[2]

send(message, error)
sys.exit(0)
