//* -*- Mode: vala; indent-tabs-mode: nil; tab-width: 4 -*-
/* Copyright (c) 2014 Adam Bieńkowski (http://launchpad.net/power-installer)
 *
 * This library is free software; you can redistribute it and/or
 * modify it under the terms of the GNU Library General Public
 * License as published by the Free Software Foundation; either
 * version 3 of the License, or (at your option) any later version.
 *
 * This library is distributed in the hope that it will be useful,
 * but WITHOUT ANY WARRANTY; without even the implied warranty of
 * MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the GNU
 * Library General Public License for more details.
 *
 * You should have received a copy of the GNU Library General Public
 * License along with this library; if not, write to the
 * Free Software Foundation, Inc., 59 Temple Place - Suite 330,
 * Boston, MA 02111-1307, USA.
 *
 * Authored by: Corentin Noel <tintou@mailoo.org>
 */

// actions tab

using GLib;
using Gtk;

namespace PowerInstaller {

    public class ActionsTab : Gtk.EventBox {
        private Gtk.Box box;

        public ActionsTab() {

            // main box
            box = new Gtk.Box(Gtk.Orientation.VERTICAL, 0);

            // all buttons
            var update = new Gtk.Button.with_label("Update repositories");
            update.clicked.connect(() => { exe_action("update", "Repositories have been succesfully updated!"); });

            var configure = new Gtk.Button.with_label("Configure all packages");
            configure.clicked.connect(() => { exe_action("configure", "All packages have been succesfully configured!"); });

            var repair = new Gtk.Button.with_label("Repair all packages");
            repair.clicked.connect(() => { exe_action("repair", "All packages have been successfully repaired!"); });

            var remove = new Gtk.Button.with_label("Remove unnecessary packages");
            remove.clicked.connect(() => { exe_action("removepkg", "Succesffully cleaned all unnecessary packages!"); });

            var ati_drivers = new Gtk.Button.with_label("Install ATI graphic drivers");
            ati_drivers.clicked.connect(() => { exe_action("ati", "ATI Drivers have been successfully installed!"); });

            var nvidia_drivers = new Gtk.Button.with_label("Install NVIDIA graphic drivers");
            nvidia_drivers.clicked.connect(() => { exe_action("nvidia", "NVIDIA Drivers have been successfully installed!"); });

            // add everything to the main box
            pack(update);
            pack(configure);
            pack(repair);
            pack(remove);
            pack(ati_drivers);
            pack(nvidia_drivers);
            this.add(box);
        }

        private void pack(Gtk.Button button) {
            box.pack_start(button, false, false, 13);
        }

        private void exe_action(string action, string msgsucess) {
            begin_show();
            execute_command_async(@"python $DATADIR/action.py '$action' '$msgsucess'");
        }
    }
}
